
#ifndef GETTABLE_H
#define GETTABLE_H

#include "lib/fixed.h"
#include "lib/endian.h"
#include "levdata.h"

#define GK_MSG_LEN 56

typedef struct {
   LE_flags32 flags;
   LE_int32 xo,yo;
   LE_int16 collect;
   LE_int16 initial;
   LE_int16 key;
   LE_int16 bulletkind;
   LE_int16 special;
   LE_int16 bullettype;
   LE_int16 shootnum;
   LE_int16 decay;
   LE_int16 usenum,bulletadd;
   LE_int32 shootarc; /* fixed! */
   char iconname[10];
   char string[GK_MSG_LEN];
   LE_int16 _spare;
   LE_int16 pickup_sound;
   LE_int16 timing;
   LE_int16 sound;
} Gettable;

#define GK_SHOOT 0x0001        /* shoots bullets, rather than missiles */
#define GK_MELEE 0x0002        /* does some kind of melee attack */
#define GK_GOT_THE 0x0004      /* display string as "You got the..." */
#define GK_WEPSELECT 0x0008    /* can use as weapon */
#define GK_SPESELECT 0x0010    /* can use as special item */
#define GK_GOT_A 0x0020        /* "You got a *" and "That * would be wasted" */
 
void init_gettables(void);
void reset_gettables(void);

void cheat_gettables(void);

int gettable_chk_key(int keytype);

void draw_gettables(void *fb,int width,int height);
void update_gettables(int ticks);

void set_gettable_special(int id,int *ptr);

void pickup_gettable(int type,int num);

void rotate_selection(int type);
void use_selection(int type,LevData *ld,int player);

void use_item(LevData *ld,int player,const Gettable *gt);

#endif
