
#ifndef LEVDYN_H
#define LEVDYN_H

#include "levdata.h"
#include "lib/fixed.h"
#include "texture.h"
#include "prothing.h"

#define LD_DYNDECL(type) void type##_dyninit(void *_dyn,const void *_lump,LevData *ld) 
#define LD_DYNINIT(type,dyn,lump) type##Dyn *dyn=_dyn;const type##Data *lump=_lump

struct LineDyn_struct;

typedef struct {
   fixed x,y,tx,ty,proj;
} VertexDyn;
LD_DYNDECL(Vertex);

typedef struct {
   Texture *utex,*mtex,*ltex;
   struct LineDyn_struct *lined;
   int uanim,manim,lanim;
   unsigned char uanimstate,manimstate,lanimstate,_spare;
} SideDyn;
LD_DYNDECL(Side);

typedef struct LineDyn_struct {
   fixed length;
   fixed cent_x,cent_y;
   char block_activation,had_keymsg,_spare1,_spare2;
} LineDyn;
LD_DYNDECL(Line);

typedef struct {
   fixed floor,ceiling;
   fixed cent_x,cent_y;
   fixed cent_r;
   Texture *ftex,*ctex;
   int fanim,canim;
   fixed dark; /* 0 is infinite light (see forever), 1 is very dark */
   unsigned char fanimstate,canimstate,sky,_spare;
   /* sky: bit 1 is ceiling, bit 2 floor */
} SectorDyn;
LD_DYNDECL(Sector);

#define MAX_SPARE_THINGS 16
typedef struct {
   fixed x,y,z;
   fixed angle,elev;
   fixed dx,dy,dz,dangle;
   ThingSignal pending_signal;
   const ProtoThing *proto;
   const ThingPhase *phase_tbl;
   short phase,phase_wait;
   Texture *image;
   int hits,armour;
   short mirror_image;
   short sector;
   short target;
   short owner;
} ThingDyn;
LD_DYNDECL(Thing);

#define ldvertexd(ld) ((VertexDyn *)(ld->dyn[ML_VERTEX]))
#define ldsectord(ld) ((SectorDyn *)(ld->dyn[ML_SECTOR]))
#define ldlined(ld) ((LineDyn *)(ld->dyn[ML_LINE]))
#define ldsided(ld) ((SideDyn *)(ld->dyn[ML_SIDE]))
#define ldthingd(ld) ((ThingDyn *)(ld->dyn[ML_THING]))

#define ldthingph(ld,on) (ldthingd(ld)[on].phase_tbl+ldthingd(ld)[on].phase)

#define wall_length(ld,ln) (ldlined(ld)[ln].length)

#endif











