
#ifndef LINETYPE_H
#define LINETYPE_H 

#include "lib/endian.h"
#include "levdata.h"

typedef struct {
   LE_flags32 flags;
   LE_int16 /*MapLumpType*/ lumptype;
   LE_int16 /*MapEventType*/ eventtype;
   LE_int16 delay;
   LE_int16 spawntype;
   LE_int16 sound,stopsound;
} LT_Action;

#define NO_ACTION(lta) ((lta)->eventtype==ME_NONE)

#define LTA_MANUAL 0x0001       /* act on back sector/side, not tagged */
#define LTA_MANUAL_FRONT 0x0002 /* act on front sector/side, not tagged */

#define MAX_LT_ACTIONS 4

typedef struct {
   LE_flags32 flags;
   LE_int16 sound;
   LE_int16 keytype,spottype;
   LT_Action action[MAX_LT_ACTIONS];
} LineType;

#define LT_REPEATABLE 0x0001
#define LT_ALLOW_PLAYER 0x0002
#define LT_ALLOW_NONPLAYER 0x0004
#define LT_ON_THUMPED 0x0008
#define LT_ON_CROSSED 0x0010
#define LT_ON_ACTIVATED 0x0020
#define LT_ON_DAMAGED 0x0040
#define LT_FRONT_ONLY 0x0080 /* only allow activation from in front */

void init_linetypes(void);
void reset_linetypes(void);

const LineType *lookup_linetype(int id);

#endif
