
#ifndef INPUT_H
#define INPUT_H

/* The PlayerInput structure contains a series of fields each of which
 * (rougly) corresponds to a command key.  The fields are integers so that
 * the input module can report the intensity with which the command was
 * issued.  This comes in handy for mice and joysticks.  Fields like
 * rotate, forward, sideways, and jump permit negative values.
 */

#define UNIT_SPEED 16

typedef struct {
   int forward;
   int rotate;
   int sideways;
   int lookup;
   int jump;
   int shoot;
   int action;
   int quit;
   int w_sel;
   int s_sel;
   int use;
   int select[16]; 
} PlayerInput;

void get_input(PlayerInput *in);

void init_input(void);
void reset_input(void);

#endif
