#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "wadwr.h"

#define ALLOCBLK 256 /* how many dirents to alloc at a time */

/*typedef struct  {
   int fout;
   WadHeader hdr;
   WadDirEntry *dir,*current;
   int maxdir;
} WADWR;*/

#define tell(fd) lseek(fd,0,SEEK_CUR)

#define sigcpy(x,y) memcpy(x,y,4)

WADWR *wadwr_open(const char *fname,char pori) {
   int f=creat(fname,S_IREAD|S_IWRITE);
   WADWR *w;
   if(f<0) return NULL;
   w=calloc(1,sizeof(WADWR));
   if(w==NULL) {
      free(w);
      return NULL;
   };
   w->f=f;
   if(pori=='i'||pori=='I') sigcpy(w->hdr.sig,"IWAD");
   else sigcpy(w->hdr.sig,"PWAD");
   w->maxdir=ALLOCBLK;
   w->dir=malloc(sizeof(WadDirEntry)*w->maxdir);
   write(w->f,&w->hdr,sizeof(WadHeader));
   return w;
};

void wadwr_close(WADWR *w) {
   w->hdr.diroffset=tell(w->f);
   write(w->f,w->dir,sizeof(WadDirEntry)*w->hdr.nlumps);
   lseek(w->f,0,SEEK_SET);
   write(w->f,&w->hdr,sizeof(WadHeader));
   close(w->f);
   free(w->dir);
   free(w);
};

void wadwr_lump(WADWR *w,const char *lumpname) {
   if(w->hdr.nlumps>=w->maxdir)  {
      w->maxdir+=ALLOCBLK;
      w->dir=realloc(w->dir,w->maxdir*sizeof(WadDirEntry));
   };
   w->current=w->dir+w->hdr.nlumps;
   w->hdr.nlumps=w->hdr.nlumps+1;
   memset(w->current,0,sizeof(WadDirEntry));
   strncpy(w->current->name,lumpname,8);
   w->current->offset=tell(w->f);
};

void wadwr_write(WADWR *w,const void *lump,size_t len) {
   if(w->current==NULL) return;
   w->current->size=w->current->size+len;
   write(w->f,lump,len);
};

